<?php
//This file is for the live inventory SSO upgrades


//Hook For Datafeed Endpoint
add_filter('foxyshop_datafeed_order', "custom_inventory_foxyshop_datafeed_order");
function custom_inventory_foxyshop_datafeed_order($transaction) {
	global $wpdb;
	if (empty($transaction->custom_fields)) return;
	foreach($transaction->custom_fields->custom_field as $custom_field) {
		if ((string)$custom_field->custom_field_name == "fc_session_id") {
			$fc_session_id = (string)$custom_field->custom_field_value;
			$sql = "DELETE FROM `foxyshop_temp_inventory` WHERE session_id = '$fc_session_id'";
			$wpdb->query($sql);
		}
	}
}




//Hook for SSO Endpoint (introduced in FoxyShop 4.1.4+)
add_action("foxyshop_sso_endpoint", "custom_inventory_foxyshop_sso_endpoint");
function custom_inventory_foxyshop_sso_endpoint() {
	global $foxyshop_settings, $wpdb;
	
	//Settings
	$inventory_timeout = 900; //seconds
	$redirect_url = "OUT-OF-STOCK-URL"; //URL to redirect to if inventory isn't available

	//DB Setup - comment this out after attempting first checkout
	$sql = "CREATE TABLE IF NOT EXISTS `foxyshop_temp_inventory` (`id` int(11) NOT NULL AUTO_INCREMENT,`session_id` varchar(100) NOT NULL,`code` varchar(100) NOT NULL,`quantity` int(11) NOT NULL DEFAULT '0',`date_added` datetime NOT NULL, PRIMARY KEY (`id`)) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
	$wpdb->query($sql);
	
	//Check Current Cart
	$ch = curl_init();
	if (!defined('FOXYSHOP_CURL_CONNECTTIMEOUT')) define('FOXYSHOP_CURL_CONNECTTIMEOUT', 10);
	if (!defined('FOXYSHOP_CURL_TIMEOUT')) define('FOXYSHOP_CURL_TIMEOUT', 15);
	curl_setopt($ch, CURLOPT_URL, "https://" . esc_attr($foxyshop_settings['domain']) . "/cart?fcsid=" . $_GET['fcsid'] . "&output=json");
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, FOXYSHOP_CURL_CONNECTTIMEOUT);
	curl_setopt($ch, CURLOPT_TIMEOUT, FOXYSHOP_CURL_TIMEOUT);
	if (defined('FOXYSHOP_CURL_SSL_VERIFYPEER')) curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FOXYSHOP_CURL_SSL_VERIFYPEER);
	$curlout = trim(curl_exec($ch));
	
	if ($curlout) {
		
		//Get Info From The Cart JSON
		$response = json_decode($curlout, true);
		$session_id = $response['session_id'];

		//Delete Old Locks and The Current Locks For This Session
		$sql = "DELETE FROM `foxyshop_temp_inventory` WHERE date_added < '" . Date("Y-m-d h:i:s", strtotime("-$inventory_timeout seconds")) . "' OR session_id = '$session_id'";
		$wpdb->query($sql);

		//Loop Through Each Product
		foreach($response['products'] as $product){
			$code = $product['code'];
			$quantity = $product['quantity'];
			$product_name = $product['name'];
			$cart_product_id = $product['name'];

			//Check Current Inventory
			$str_meta_value = strlen(preg_replace("/[^0-9]/","", $code)) == strlen($code) ? mysql_real_escape_string($code) . ";" : '"' . mysql_real_escape_string($code) . '";';
			$sql = "SELECT `meta_value` FROM $wpdb->postmeta WHERE `meta_key` = '_inventory_levels' AND `meta_value` LIKE '%" . $str_meta_value . "%'";
			$product_check = $wpdb->get_var($sql);
			$inventory_levels = "";
			if ($product_check) {
				$inventory_levels = maybe_unserialize($product_check);

				//Found Inventory Levels
				if (is_array($inventory_levels)) {
					
					$current_inventory_level = (int)$inventory_levels[$code]['count'];
					
					//Check Temporary Count
					$current_temp_count = (int)$wpdb->get_var("SELECT SUM(quantity) FROM `foxyshop_temp_inventory` WHERE code = '$code'");
					$new_count = $current_inventory_level - $current_temp_count - $quantity;

					//Inventory count is now negative
					if ($new_count < 0) {
						
						//Remove Product From Cart
						$ch = curl_init();
						if (!defined('FOXYSHOP_CURL_CONNECTTIMEOUT')) define('FOXYSHOP_CURL_CONNECTTIMEOUT', 10);
						if (!defined('FOXYSHOP_CURL_TIMEOUT')) define('FOXYSHOP_CURL_TIMEOUT', 15);
						curl_setopt($ch, CURLOPT_URL, "https://" . esc_attr($foxyshop_settings['domain']) . "/cart?fcsid=" . $_GET['fcsid'] . "&cart=update&quantity=0&id=".$cart_product_id);
						curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
						curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, FOXYSHOP_CURL_CONNECTTIMEOUT);
						curl_setopt($ch, CURLOPT_TIMEOUT, FOXYSHOP_CURL_TIMEOUT);
						if (defined('FOXYSHOP_CURL_SSL_VERIFYPEER')) curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FOXYSHOP_CURL_SSL_VERIFYPEER);
						$curlout = trim(curl_exec($ch));
						
						//Redirect to "sorry" message
						header('Location: ' . $redirect_url . "?product_name=" . urlencode($product_name) . "&product_code=" . urlencode($code));
						die;
					}

					//Add New Locks For This Product
					$data = array(
						"session_id" => $session_id,
						"code" => $code,
						"quantity" => $quantity,
						"date_added" => Date("Y-m-d h:i:s")
					);
					$format = array(
						"%s",
						"%s",
						"%d",
						"%s",
					);
					$wpdb->insert("foxyshop_temp_inventory", $data, $format);
				}
			}

			//Add Session ID as a custom field so that we can track it later on
			$ch = curl_init();
			if (!defined('FOXYSHOP_CURL_CONNECTTIMEOUT')) define('FOXYSHOP_CURL_CONNECTTIMEOUT', 10);
			if (!defined('FOXYSHOP_CURL_TIMEOUT')) define('FOXYSHOP_CURL_TIMEOUT', 15);
			curl_setopt($ch, CURLOPT_URL, "https://" . esc_attr($foxyshop_settings['domain']) . "/cart?fcsid=" . $_GET['fcsid'] . "&h:fc_session_id=".$session_id);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, FOXYSHOP_CURL_CONNECTTIMEOUT);
			curl_setopt($ch, CURLOPT_TIMEOUT, FOXYSHOP_CURL_TIMEOUT);
			if (defined('FOXYSHOP_CURL_SSL_VERIFYPEER')) curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FOXYSHOP_CURL_SSL_VERIFYPEER);
			$curlout = trim(curl_exec($ch));

		}
	}

	//Redirect Back to FoxyCart
	$fcsid = $_GET['fcsid'];
	$timestamp = $_GET['timestamp'];
	$newtimestamp = strtotime("+60 minutes", $timestamp);

	$auth_token = sha1($customer_id . '|' . $newtimestamp . '|' . $foxyshop_settings['api_key']);

	$redirect_complete = 'https://' . $foxyshop_settings['domain'] . '/checkout?fc_auth_token=' . $auth_token . '&fcsid=' . $fcsid . '&h:inventory_timeout=1&timestamp=' . $newtimestamp;
	header('Location: ' . $redirect_complete);
	die;
}

